﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.WinForms;

namespace _9288
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.MapClick += WinformsMap1_MapClick;

            //ShapeFileFeatureLayer.BuildIndexFile(@"..\..\AppData\STR_4.shp", BuildIndexMode.Rebuild);

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\STR_4.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            winformsMap1.Overlays.Add(layerOverlay);

            InMemoryFeatureLayer layer2 = new InMemoryFeatureLayer();
            layer2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Grass1;
            layer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            LayerOverlay overlay2 = new LayerOverlay();
            overlay2.Layers.Add(layer2);
            winformsMap1.Overlays.Add(overlay2);

            shapeFileLayer.Open();
            winformsMap1.CurrentExtent = shapeFileLayer.GetBoundingBox();
            winformsMap1.Refresh();
        }

        private void WinformsMap1_MapClick(object sender, MapClickWinformsMapEventArgs e)
        {
            FeatureLayer shapeFileLayer = (FeatureLayer)((LayerOverlay)winformsMap1.Overlays[0]).Layers[0];
            InMemoryFeatureLayer mapShapeLayer = (InMemoryFeatureLayer)((LayerOverlay)winformsMap1.Overlays[1]).Layers[0];
            shapeFileLayer.Open();
            
            Feature feature = shapeFileLayer.FeatureSource.GetFeaturesByColumnValue("UID", "PR71_1")[0];
            //Feature feature = shapeFileLayer.FeatureSource.GetFeatureById("1", new string[1] { "UID" });

            shapeFileLayer.Close();
            mapShapeLayer.InternalFeatures.Clear();
            mapShapeLayer.InternalFeatures.Add(feature.Id, feature);
            winformsMap1.Refresh(winformsMap1.Overlays[1]);
        }
    }
}
